Index: mesa-9.2.2/src/mesa/main/dd.h
===================================================================
--- mesa-9.2.2.orig/src/mesa/main/dd.h	2013-10-24 15:08:20.471761488 +0100
+++ mesa-9.2.2/src/mesa/main/dd.h	2013-10-24 15:11:00.929761469 +0100
@@ -661,9 +661,13 @@
    /*@{*/
    struct gl_shader *(*NewShader)(struct gl_context *ctx, GLuint name, GLenum type);
    void (*DeleteShader)(struct gl_context *ctx, struct gl_shader *shader);
+   void (*CompileShader)(struct gl_context *ctx, struct gl_shader *shader);
+
    struct gl_shader_program *(*NewShaderProgram)(struct gl_context *ctx, GLuint name);
    void (*DeleteShaderProgram)(struct gl_context *ctx,
                                struct gl_shader_program *shProg);
+   void (*LinkShaderProgram)(struct gl_context *ctx,
+                             struct gl_shader_program *shProg);struct gl_shader_program *shProg);
    void (*UseProgram)(struct gl_context *ctx, struct gl_shader_program *shProg);
    /*@}*/
 
Index: mesa-9.2.2/src/mesa/main/shaderapi.c
===================================================================
--- mesa-9.2.2.orig/src/mesa/main/shaderapi.c	2013-10-24 15:08:20.471761488 +0100
+++ mesa-9.2.2/src/mesa/main/shaderapi.c	2013-10-24 15:12:33.280761458 +0100
@@ -761,7 +761,7 @@
       /* this call will set the shader->CompileStatus field to indicate if
        * compilation was successful.
        */
-      _mesa_glsl_compile_shader(ctx, sh, false, false);
+      ctx->Driver.CompileShader(ctx, sh, false, false);
 
       if (ctx->Shader.Flags & GLSL_LOG) {
          _mesa_write_shader_to_file(sh);
@@ -817,6 +817,7 @@
    FLUSH_VERTICES(ctx, _NEW_PROGRAM);
 
    _mesa_glsl_link_shader(ctx, shProg);
+   ctx->Driver.LinkShaderProgram(ctx, shProg);
 
    if (shProg->LinkStatus == GL_FALSE && 
        (ctx->Shader.Flags & GLSL_REPORT_ERRORS)) {
Index: mesa-9.2.2/src/mesa/main/shaderobj.c
===================================================================
--- mesa-9.2.2.orig/src/mesa/main/shaderobj.c	2013-10-24 15:08:20.472761488 +0100
+++ mesa-9.2.2/src/mesa/main/shaderobj.c	2013-10-24 15:14:11.248761446 +0100
@@ -344,7 +344,7 @@
    shProg->TransformFeedback.VaryingNames = NULL;
    shProg->TransformFeedback.NumVarying = 0;
 
-
+   /* we should be dereferencing shaders instead of plainly deleting them */
    for (sh = 0; sh < MESA_SHADER_TYPES; sh++) {
       if (shProg->_LinkedShaders[sh] != NULL) {
 	 ctx->Driver.DeleteShader(ctx, shProg->_LinkedShaders[sh]);
@@ -422,7 +422,9 @@
 {
    driver->NewShader = _mesa_new_shader;
    driver->DeleteShader = _mesa_delete_shader;
+   driver->CompileShader = _mesa_glsl_compile_shader;
    driver->NewShaderProgram = _mesa_new_shader_program;
    driver->DeleteShaderProgram = _mesa_delete_shader_program;
+   driver->LinkShaderProgram = _mesa_glsl_link_shader;
    driver->LinkShader = _mesa_ir_link_shader;
 }
